## lomiri 0.5.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.7.0)

# Default install location. Must be set here, before setting the project.
if (NOT DEFINED CMAKE_INSTALL_PREFIX)
    set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "" FORCE)
endif()

project(lomiri VERSION 0.5.0 LANGUAGES C CXX)

option (ENABLE_UBUNTU_ACCOUNTSSERVICE "Build with Ubuntu's fork of accountsservice" OFF)

if (ENABLE_UBUNTU_ACCOUNTSSERVICE)
    add_compile_definitions (ENABLE_UBUNTU_ACCOUNTSSERVICE)
endif ()

set(SHELL_APP lomiri)
set(INDICATORS_CLIENT_APP indicators-client)
set(GREETER_APP lomiri-greeter)

set (DESKTOP_FILE_SHELL "${SHELL_APP}.desktop")
set (DESKTOP_FILE_GREETER "${GREETER_APP}.desktop")
set (DESKTOP_FILE_INDICATORSCLIENT "${INDICATORS_CLIENT_APP}.desktop")
set(QML_DEBUG OFF CACHE BOOL "Enable Qml Debugging")

if(${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
   message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

# Instruct CMake to run moc and rcc automatically when needed.
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

# enable QML debugging
if(QML_DEBUG)
    add_definitions(-DQT_QML_DEBUG)
endif()

include(EnableCoverageReport)
#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage (or ninja if you use that backend)
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
if(cmake_build_type_lower MATCHES coverage)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage" )
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage" )
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} --coverage" )
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --coverage" )
  ENABLE_COVERAGE_REPORT(TARGETS ${SHELL_APP} FILTER /usr/include ${CMAKE_SOURCE_DIR}/tests/* ${CMAKE_BINARY_DIR}/*)
endif()

find_package (ECM 1.7.0 QUIET NO_MODULE)
if (ECM_FOUND)
    # Provides us with -DECM_ENABLE_SANITIZERS='X'
    # Where X can be address, thread, memory, leak, undefined
    include("${ECM_MODULE_DIR}/ECMEnableSanitizers.cmake")
endif()

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS "5.0.0")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsuggest-override" )
  endif()
endif()

# Make sure we have all the needed symbols
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,defs")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-z,defs")

# Static C++ checks
add_custom_target(cppcheck COMMAND cppcheck --enable=all -q --error-exitcode=2
                                       ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/tests)

include(FindPkgConfig)
find_package(Qt5Core 5.6 REQUIRED)
find_package(Qt5Qml 5.6 REQUIRED)
find_package(Qt5Quick 5.6 REQUIRED)
find_package(Qt5Gui 5.6 REQUIRED)
find_package(Qt5DBus 5.6 REQUIRED)
find_package(Qt5Concurrent 5.6 REQUIRED)
find_package(Qt5Sql 5.6 REQUIRED)
find_package(Qt5Test 5.6 REQUIRED)
find_package(Qt5Svg 5.6 REQUIRED)
find_package(Qt5Network 5.6 REQUIRED)
find_package(Qt5Xml 5.6 REQUIRED)
find_package(Intl REQUIRED)

pkg_check_modules(APPLICATION_API REQUIRED lomiri-shell-application=28)
pkg_check_modules(GEONAMES REQUIRED geonames>=0.2)
pkg_check_modules(GIO REQUIRED gio-2.0>=2.32)
pkg_check_modules(GLIB REQUIRED glib-2.0>=2.32)
pkg_check_modules(LAUNCHER_API REQUIRED lomiri-shell-launcher=13)
pkg_check_modules(QMENUMODEL REQUIRED qmenumodel)
pkg_check_modules(GD3 REQUIRED gnome-desktop-3.0)
# 0.1.5 adds lal-application-end.target.
pkg_check_modules(UAL REQUIRED lomiri-app-launch-0>=0.1.5)
pkg_check_modules(LOMIRIGESTURES REQUIRED LomiriGestures)
pkg_check_modules(DEVICEINFO REQUIRED deviceinfo)
pkg_check_modules(LOMIRISCHEMA REQUIRED lomiri-schemas>=0.1.4)
pkg_check_modules(LIBLIGHTDM REQUIRED liblightdm-qt5-3)

option(WITH_MIR2 "Build against Mir 2" OFF)

if (WITH_MIR2)
    pkg_check_modules(QTMIRSERVER REQUIRED qt5mir2server>=0.6.0)
    pkg_check_modules(MIRAL REQUIRED miral>=3.0)
    pkg_check_modules(MIROIL REQUIRED miroil)

    add_definitions(-DWITH_MIR2=1)
else()
    pkg_check_modules(QTMIRSERVER REQUIRED qt5mir1server>=0.6.0)
    pkg_search_module(MIRAL REQUIRED mir1al miral<3.0)
endif()

### Check LomiriGestures private headers. No pkg-config (.pc) file is provided for them
find_path(LOMIRIGESTUREPRIV
    NAMES LomiriGestures/private/damper_p.h LomiriGestures/private/ucswipearea_p.h LomiriGestures/private/ucswipearea_p_p.h
    PATHS ${LOMIRIGESTURES_INCLUDEDIR}/LomiriGestures/${LOMIRIGESTURES_VERSION}
    NO_DEFAULT_PATH)
if (${LOMIRIGESTUREPRIV} STREQUAL LOMIRIGESTUREPRIV-NOTFOUND)
   message(FATAL_ERROR "LomiriGestures private headers not found.")
endif()
# end of LomiriGesture private headers check

# Standard install paths
include(GNUInstallDirs)

set(SHELL_APP_FULL_DIR ${CMAKE_INSTALL_FULL_DATADIR}/lomiri)
add_definitions(-DSHELL_APP_FULL_DIR=\"${SHELL_APP_FULL_DIR}\")
set(SHELL_PRIVATE_FULL_LIBDIR ${CMAKE_INSTALL_FULL_LIBDIR}/lomiri)
set(SHELL_PRIVATE_FULL_LIBEXECDIR ${CMAKE_INSTALL_FULL_LIBEXECDIR}/lomiri)

execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=plugin_private_module_dir LomiriSystemSettings OUTPUT_VARIABLE LOMIRI_SYSTEM_SETTINGS_PRIVATE_PLUGINDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
if(LOMIRI_SYSTEM_SETTINGS_PRIVATE_PLUGINDIR STREQUAL "")
    message(FATAL_ERROR "Could not determine LomiriSystemSettings private plugin installation dir.")
endif()

execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=plugindir_suffix lomiri-shell-api OUTPUT_VARIABLE SHELL_INSTALL_QML OUTPUT_STRIP_TRAILING_WHITESPACE)
if(SHELL_INSTALL_QML STREQUAL "")
    message(FATAL_ERROR "Could not determine plugin installation dir.")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")

execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=plugindir lomiri-shell-api OUTPUT_VARIABLE SHELL_PLUGINDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
if(SHELL_PLUGINDIR STREQUAL "")
    message(FATAL_ERROR "Could not determine plugin import dir.")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-permissive -pedantic -Wall -Wextra")

set (CMAKE_CXX_STANDARD 17)

if ("${CMAKE_BUILD_TYPE}" STREQUAL "release" OR "${CMAKE_BUILD_TYPE}" STREQUAL "relwithdebinfo")
    option(Werror "Treat warnings as errors" ON)
else()
    option(Werror "Treat warnings as errors" OFF)
endif()

if (Werror)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

# gtk and lomiri-core (actually sigc++) do not like Qt defining macros named
# "signals" and "slots"
add_definitions(-DQT_NO_KEYWORDS)

# Save a few container detach and conversions
add_definitions(-DQT_STRICT_ITERATORS)

# Use the fast string builder
add_definitions(-DQT_USE_QSTRINGBUILDER)

# Autopilot tests
include(autopilot)
declare_autopilot_test(shell lomiri.shell ${CMAKE_SOURCE_DIR}/tests/autopilot/)

set(MOCK_INDICATOR_SERVICE_APP lomiri-mock-indicator-service)

include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_BINARY_DIR}/include
    ${APPLICATION_API_INCLUDE_DIRS}
)

# Quiet logger
set(QUIET_LOGGER OFF CACHE BOOL "Disable test output on stdout.")
if(NOT QUIET_LOGGER)
    set(STDOUT_LOGGER "-o" "-,txt")
endif()

execute_process(COMMAND dpkg-architecture -qDEB_HOST_ARCH OUTPUT_VARIABLE ARCH)
if (NOT ARCH MATCHES "arm*")
    set(ENABLE_TOUCH_EMULATION true)
    add_definitions(-DLOMIRI_ENABLE_TOUCH_EMULATION)
    pkg_check_modules(MOUSETOUCHADAPTOR_LIBS REQUIRED x11 xcb xi)
else()
    set(ENABLE_TOUCH_EMULATION false)
    message(STATUS "Touch emulation support disabled.")
endif()

# add subdirectories to build
add_subdirectory(include)
add_subdirectory(src)
add_subdirectory(tools)
add_subdirectory(qml)

# Tests
set(NO_TESTS OFF CACHE BOOL "Disable tests.")
if (NOT NO_TESTS)
    pkg_check_modules(QTDBUSTEST REQUIRED
        libqtdbustest-1
        libqtdbusmock-1
        )
    include(CTest)
    enable_testing()
    add_subdirectory(tests)
else()
    message(STATUS "Tests disabled")
endif()

set(DISPLAYED_DISTRO_NAME "" CACHE STRING
    "The distro name displayed in first-run wizard and other places. If not set, will read /etc/os-release")
add_subdirectory(plugins)

#
# Data files
#
add_subdirectory(data)

#
# Translation
#
add_subdirectory(po)

#
# Documentation
#
add_subdirectory(doc)

=== data/CMakeLists.txt ===
include(FindGettext)

# generate desktop files
configure_file(${DESKTOP_FILE_SHELL}.in.in ${DESKTOP_FILE_SHELL}.in)
add_custom_target(${DESKTOP_FILE_SHELL} ALL
    COMMENT "Merging translations into ${DESKTOP_FILE_SHELL}..."
    COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}
            --desktop --template=${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE_SHELL}.in
            -o ${DESKTOP_FILE_SHELL}
            -d ${CMAKE_SOURCE_DIR}/po
)

configure_file(${DESKTOP_FILE_GREETER}.in.in ${DESKTOP_FILE_GREETER}.in)
add_custom_target(${DESKTOP_FILE_GREETER} ALL
    COMMENT "Merging translations into ${DESKTOP_FILE_GREETER}..."
    COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}
            --desktop --template=${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE_GREETER}.in
            -o ${DESKTOP_FILE_GREETER}
            -d ${CMAKE_SOURCE_DIR}/po
)

configure_file(${DESKTOP_FILE_INDICATORSCLIENT}.in.in ${DESKTOP_FILE_INDICATORSCLIENT}.in)
add_custom_target(${DESKTOP_FILE_INDICATORSCLIENT} ALL
    COMMENT "Merging translations into ${DESKTOP_FILE_INDICATORSCLIENT}..."
    COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}
            --desktop --template=${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE_INDICATORSCLIENT}.in
            -o ${DESKTOP_FILE_INDICATORSCLIENT}
            -d ${CMAKE_SOURCE_DIR}/po
)

# install desktop files
install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/${SHELL_APP}.desktop
    ${CMAKE_CURRENT_BINARY_DIR}/${INDICATORS_CLIENT_APP}.desktop
    DESTINATION ${CMAKE_INSTALL_DATADIR}/applications
    )

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/${GREETER_APP}.desktop
    DESTINATION ${CMAKE_INSTALL_DATADIR}/lightdm/greeters
    )

install(FILES
    51-lomiri-greeter.conf
    DESTINATION ${CMAKE_INSTALL_DATADIR}/lightdm/lightdm.conf.d
    )

add_custom_target(pkgversion ALL COMMAND echo ${PROJECT_VERSION} | head -n1 > ${CMAKE_CURRENT_BINARY_DIR}/version)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/version DESTINATION ${CMAKE_INSTALL_LOCALSTATEDIR}/lib/lomiri)

add_subdirectory(systemd-user)

=== include/CMakeLists.txt ===
configure_file(paths.h.in ${CMAKE_CURRENT_BINARY_DIR}/paths.h @ONLY)

=== plugins/CMakeLists.txt ===
find_package(QmlPlugins)

# Set up and install a plugin for lomiri.
#
# add_lomiri_plugin(plugin version path
#     [...]  # See export_qmlfiles and export_qmlplugin documentation for more options
# )

macro(add_lomiri_plugin PLUGIN VERSION PATH)
    export_qmlfiles(${PLUGIN} ${PATH} DESTINATION ${SHELL_INSTALL_QML} ${ARGN})
    export_qmlplugin(${PLUGIN} ${VERSION} ${PATH} DESTINATION ${SHELL_INSTALL_QML} ${ARGN})
endmacro()

add_subdirectory(AccountsService)
add_subdirectory(BatteryMonitor)
add_subdirectory(Cursor)
add_subdirectory(GlobalShortcut)
add_subdirectory(Greeter)
add_subdirectory(LightDM)
add_subdirectory(Powerd)
add_subdirectory(ProcessControl)
add_subdirectory(ScreenshotDirectory)
add_subdirectory(SessionBroadcast)
add_subdirectory(Lomiri)
add_subdirectory(UInput)
add_subdirectory(Utils)
add_subdirectory(WindowManager)
add_subdirectory(Wizard)

=== po/CMakeLists.txt ===
include(FindGettext)

find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)
if("${GETTEXT_XGETTEXT_EXECUTABLE}" STREQUAL "GETTEXT_XGETTEXT_EXECUTABLE-NOTFOUND")
    message(FATAL_ERROR "Could not find xgettext")
endif()

set(DOMAIN ${PROJECT_NAME})
set(POT_FILE ${DOMAIN}.pot)

file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/LINGUAS LINGUAS
     REGEX "^[^#].*")
string(REGEX MATCHALL "[^ \t]+" LANGS "${LINGUAS}")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/POTFILES.in
               ${CMAKE_CURRENT_BINARY_DIR}/POTFILES COPYONLY)

add_custom_target(${POT_FILE} ALL
                  COMMENT "Generating translation template"
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          --from-code=UTF-8
                          --language=Desktop
                          --package-name='${PROJECT_NAME}'
                          --copyright-holder='Canonical Ltd.'
                          -D ${CMAKE_BINARY_DIR}
                          data/${DESKTOP_FILE_SHELL}.in
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          --from-code=UTF-8
                          --language=Desktop
                          --package-name='${PROJECT_NAME}'
                          --copyright-holder='Canonical Ltd.'
                          --join-existing
                          -D ${CMAKE_BINARY_DIR}
                          data/${DESKTOP_FILE_GREETER}.in
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          --from-code=UTF-8
                          --language=Desktop
                          --package-name='${PROJECT_NAME}'
                          --copyright-holder='Canonical Ltd.'
                          --join-existing
                          -D ${CMAKE_BINARY_DIR}
                          data/${DESKTOP_FILE_INDICATORSCLIENT}.in
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          -D ${CMAKE_SOURCE_DIR}
                          -D ${CMAKE_CURRENT_SOURCE_DIR}
                          -D ${CMAKE_CURRENT_BINARY_DIR}
                          --from-code=UTF-8
                          --c++
                          --qt
                          --add-comments=TRANSLATORS
                          --keyword=_ --keyword=tr --keyword=tr:1,2
                          --keyword=dtr:2 --keyword=dtr:2,3
                          --keyword=ctr:1c,2 --keyword=dctr:2c,3
                          --keyword=tag --keyword=tag:1c,2
                          --keyword=dgettext_datetime
                          --package-name='${PROJECT_NAME}'
                          --copyright-holder='Canonical Ltd.'
                          --join-existing --files-from=${CMAKE_CURRENT_BINARY_DIR}/POTFILES)

foreach(LANG ${LANGS})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${LANG}.po
                   ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.po
                   COPYONLY)
endforeach(LANG)
gettext_process_pot_file(${POT_FILE} ALL
                         INSTALL_DESTINATION ${CMAKE_INSTALL_LOCALEDIR}
                         LANGUAGES ${LANGS})

=== qml/CMakeLists.txt ===
file(GLOB QML_JS_FILES *.qml *.js qmldir)

install(FILES ${QML_JS_FILES}
    DESTINATION ${SHELL_APP_FULL_DIR}
    )

set(QML_DIRS
    ApplicationMenus
    Components
    graphics
    Greeter
    Launcher
    Notifications
    Panel
    Stage
    Rotation
    Tutorial
    Wizard
    )

install(DIRECTORY ${QML_DIRS}
    DESTINATION ${SHELL_APP_FULL_DIR}
    )

=== tests/CMakeLists.txt ===
include(QmlTest)

# QML tests that do not require graphical capabilities.
add_meta_test(unittests)

# QML tests that require graphical capabilities.
add_meta_test(uitests)
add_meta_test(xvfbuitests)

# Run our meta-meta tests serially because we don't need to nest
# parallelized tests.
add_meta_test(alltests SERIAL DEPENDS unittests uitests)
add_meta_test(xvfballtests SERIAL DEPENDS unittests xvfbuitests)

# Support libraries and plugins
add_subdirectory(mocks)
add_subdirectory(utils)
add_subdirectory(uqmlscene)

# Use our custom implementation of qmlscene and import dbus-test-runner
add_executable(qmlscene ALIAS uqmlscene)
import_executables(dbus-test-runner)
import_executables(qdbus-simple-test-runner)

set(LOMIRI_PLUGINPATH "${CMAKE_BINARY_DIR}/plugins" CACHE PATH "Path to pre-built lomiri plugin dir.")
set(LOMIRI_MOCKPATH "${CMAKE_BINARY_DIR}/tests/mocks" CACHE PATH "Path to pre-built lomiri mock dir.")

# Pre-built mocks have preference, pre-built plugins replace local build
set(LOMIRI_IMPORT_PATHS
    ${LOMIRI_MOCKPATH}
    ${CMAKE_BINARY_DIR}/tests/mocks
    ${CMAKE_BINARY_DIR}/tests/utils/modules
    ${LOMIRI_PLUGINPATH}
)
list(REMOVE_DUPLICATES LOMIRI_IMPORT_PATHS)
set(LOMIRI_IMPORT_PATHS ${LOMIRI_IMPORT_PATHS} CACHE INTERNAL "")

macro(lomiri_parse_arguments)
    cmake_parse_arguments(U8TEST
        "${QMLTEST_OPTIONS}"
        "${QMLTEST_SINGLE}"
        "${QMLTEST_MULTI}"
        ${ARGN}
    )

    set(ld_paths)
    list(APPEND ld_paths
        ${LOMIRI_MOCKPATH}/liblightdm
        ${LOMIRI_MOCKPATH}/libusermetrics
        ${LOMIRI_MOCKPATH}/WindowManager
    )

    string(REPLACE ";" ":" ld_library_path "${ld_paths}")
    set(ld_library_path LD_LIBRARY_PATH=${ld_library_path})

    set(U8TEST_ARGN "${ARGN}")

    set(environment
        LOMIRI_TESTING=1
        LANGUAGE=C
        LC_ALL=C.UTF-8
        ${ld_library_path}
    )
endmacro()


# add a non-graphical unit test
# see QmlTest.cmake for additional options
function(add_lomiri_unittest COMPONENT_NAME TARGET)
    lomiri_parse_arguments(${ARGN})
    add_executable_test(${COMPONENT_NAME} ${TARGET}
        ADD_TEST
        IMPORT_PATHS ${LOMIRI_IMPORT_PATHS}
        TARGETS unittests
        ${U8TEST_ARGN}
        ENVIRONMENT ${environment}
                    ${U8TEST_ENVIRONMENT}
                    QT_QPA_PLATFORM=minimal
                    UITK_ICON_THEME=suru
    )
endfunction()

# add a graphical unit test
function(add_lomiri_uitest COMPONENT_NAME TARGET)
    lomiri_parse_arguments(${ARGN})
    add_executable_test(${COMPONENT_NAME} ${TARGET}
        IMPORT_PATHS ${LOMIRI_IMPORT_PATHS}
        TARGETS uitests
        ${U8TEST_ARGN}
        ENVIRONMENT ${environment}
                    ${U8TEST_ENVIRONMENT}
                    UITK_ICON_THEME=suru
    )
endfunction()

# add a non-graphical qml unit test
function(add_lomiri_qmlunittest PATH COMPONENT_NAME)
    lomiri_parse_arguments(${ARGN})
    add_qml_unittest(${PATH} ${COMPONENT_NAME}
        ADD_TEST
        IMPORT_PATHS ${LOMIRI_IMPORT_PATHS}
        TARGET unittests
        ${U8TEST_ARGN}
        ENVIRONMENT ${environment}
                    ${U8TEST_ENVIRONMENT}
                    QT_QPA_PLATFORM=minimal
                    UITK_ICON_THEME=suru
    )
endfunction()

# add a graphical qml test
function(add_lomiri_qmltest PATH COMPONENT_NAME)
    lomiri_parse_arguments(${ARGN})
    add_qml_test(${PATH} ${COMPONENT_NAME}
        IMPORT_PATHS ${LOMIRI_IMPORT_PATHS}
        TARGETS uitests
        ${U8TEST_ARGN}
        ENVIRONMENT ${environment}
                    ${U8TEST_ENVIRONMENT}
                    UITK_ICON_THEME=suru
    )
endfunction()

# add a graphical qml benchmark
function(add_lomiri_qmlbenchmark PATH COMPONENT_NAME ITERATIONS)
    add_lomiri_qmltest(${PATH} ${COMPONENT_NAME} ITERATIONS ${ITERATIONS} ${ARGN})
endfunction()

# add files needed for qml tests, just here for better alignment with add_lomiri_qmltest
function(add_lomiri_qmltest_data PATH COMPONENT_NAME)
    add_qml_test_data("${PATH}" "${COMPONENT_NAME}")
endfunction()

# used to make dbus adaptor classes from xml to mock system services
if(DEFINED ENV{DEB_BUILD_MULTIARCH})
  set(QDBUSXML2CPP_EXECUTABLE "/usr/lib/$ENV{DEB_BUILD_MULTIARCH}/qt5/bin/qdbusxml2cpp")
else()
  FIND_PROGRAM(QDBUSXML2CPP_EXECUTABLE qdbusxml2cpp)
endif()

if(NOT QDBUSXML2CPP_EXECUTABLE)
    message(FATAL_ERROR "qdbusxml2cpp not found")
endif()

install(DIRECTORY data graphics
    DESTINATION "${SHELL_APP_FULL_DIR}/tests"
)


# Actual test definitions
add_subdirectory(plugins)
add_subdirectory(qmltests)
add_subdirectory(whitespace)
add_subdirectory(imports)
add_subdirectory(copyright)

=== data/systemd-user/CMakeLists.txt ===
pkg_check_modules(SYSTEMD systemd)

if (${SYSTEMD_FOUND})
    find_program(DUAE_BIN dbus-update-activation-environment REQUIRED)
    find_program(XWAYLAND_BIN Xwayland REQUIRED)

    if (${SYSTEMD_VERSION} VERSION_LESS 247)
        pkg_get_variable(SYSTEMD_USER_UNIT_DIR systemd systemduserunitdir)
    else()
        pkg_get_variable(SYSTEMD_USER_UNIT_DIR systemd systemd_user_unit_dir)
    endif()

    # lomiri-<MODE>.service

    set(MODES full-greeter full-shell greeter shell)

    foreach(MODE ${MODES})
        configure_file(
            lomiri-MODE.service.in
            ${CMAKE_CURRENT_BINARY_DIR}/lomiri-${MODE}.service
            @ONLY
        )

        install(FILES
            ${CMAKE_CURRENT_BINARY_DIR}/lomiri-${MODE}.service
            DESTINATION ${SYSTEMD_USER_UNIT_DIR}
        )
    endforeach()

    # lomiri-indicators.target

    install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/lomiri-indicators.target" DESTINATION "${SYSTEMD_USER_UNIT_DIR}")

endif()

# lomiri-systemd-wrapper

configure_file(lomiri-systemd-wrapper.in ${CMAKE_CURRENT_BINARY_DIR}/lomiri-systemd-wrapper @ONLY)
install(PROGRAMS
    ${CMAKE_CURRENT_BINARY_DIR}/lomiri-systemd-wrapper
    DESTINATION ${CMAKE_INSTALL_FULL_LIBEXECDIR}
)

# Xwayland startup script

configure_file(Xwayland.lomiri.in ${CMAKE_CURRENT_BINARY_DIR}/Xwayland.lomiri @ONLY)
install(PROGRAMS
    ${CMAKE_CURRENT_BINARY_DIR}/Xwayland.lomiri
    DESTINATION ${CMAKE_INSTALL_FULL_LIBEXECDIR}
)

=== plugins/BatteryMonitor/CMakeLists.txt ===
set(SRC
    plugin.cpp
    BatteryMonitor.cpp
)

add_library(BatteryMonitor MODULE ${SRC})

target_link_libraries(BatteryMonitor Qt5::DBus Qt5::Qml)

add_lomiri_plugin(BatteryMonitor 1.0 BatteryMonitor TARGETS BatteryMonitor)

=== plugins/GlobalShortcut/CMakeLists.txt ===
set(globalshortcutplugin_SRCS
    globalshortcut.cpp
    globalshortcutregistry.cpp
    plugin.cpp)

add_library(GlobalShortcut-qml SHARED ${globalshortcutplugin_SRCS})

target_link_libraries(GlobalShortcut-qml Qt5::Quick Qt5::Gui)

add_lomiri_plugin(GlobalShortcut 1.0 GlobalShortcut TARGETS GlobalShortcut-qml)

=== plugins/LightDM/CMakeLists.txt ===
pkg_check_modules(LIBUSERMETRICSOUTPUT REQUIRED libusermetricsoutput-1)

find_package(Qt5Core REQUIRED)
find_package(Qt5Quick REQUIRED)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}/plugins/Utils
    ${liblomiri-private_SOURCE_DIR}
    ${LIBUSERMETRICSOUTPUT_INCLUDE_DIRS}
)

set(QMLPLUGIN_SRC
    ../Utils/lomirisortfilterproxymodelqml.cpp
    DBusGreeter.cpp
    DBusGreeterList.cpp
    Greeter.cpp
    plugin.cpp
    PromptsModel.cpp
    SessionsModel.cpp
    UsersModel.cpp
    )

add_subdirectory(FullLightDM)
add_subdirectory(IntegratedLightDM)

=== plugins/Lomiri/CMakeLists.txt ===
add_subdirectory(Gestures)
add_subdirectory(DownloadDaemonListener)
add_subdirectory(ApplicationMenu)
add_subdirectory(ModemConnectivity)
add_subdirectory(Indicators)
add_subdirectory(Launcher)
add_subdirectory(Session)
add_subdirectory(InputInfo)
add_subdirectory(Platform)

=== debian/changelog ===
lomiri (0.5.0-6) unstable; urgency=medium

  * debian/patches:
    + Add 0035_DisplayConfigurationStorage-drop-use-of-edid-descriptors.patch.
      Drop use of edid descriptors in DisplayConfigurationStorage.cpp. Make
      way for bumping Mir from 2.20.x to Mir 2.22.x.
    + Add patches 0041 - 0046. Add support for watching icon directories and
      update icons in icon cache and in launcher if changes occur.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 28 Aug 2025 10:28:47 +0200

lomiri (0.5.0-5) unstable; urgency=medium

  * Revert "debian/patches: update patches 0033 and 0034 after upstream MR has
    been updated"
  * Revert "debian/patches: Add 0033_remove-dangling-window-decorations-from-
    model.patch. qml & plugins: Remove dangling window decorations from model.
    Latch onto MirSurface signal indicating it's not being displayed anymore,
    and remove the window from the TopLevelWindowModel when required."
  * debian/patches:
    + Rename 1001_use-com-lomiri-Shell-pictureUri.patch to 1001a_use-com-lomiri-
      Shell-pictureUri.patch.
    + Add 1001b_qml-Shell.qml-Dynamically-switch-gsettings-context-f.patch. Fix
      dynamically switching background images if they differ between
      com.lomiri.Shell and com.lomiri.Shell.Greeter. Relevant when Debian Edu
      Artwork is in use.
    + Trivially rebase 0032_dont-ask-for-SIM-PIN-in-greeter.patch.
    + Add 0033_fix-multi-process-app-having-phantom-window.patch. Fix multi-
      process app having phantom window. (Can cause session crashes when trying
      to close those windows).
  * debian/control:
    + Update versioned D:s on qtmir (and co.) to 0.8.0~git20250407.ea2f477-3~.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 11 Aug 2025 18:10:35 +0200

lomiri (0.5.0-4) unstable; urgency=medium

  * debian/patches:
    + Add 0031_faster-session-exit.patch. Exit out of the process with the
      respective exit code.
    + Add 0032_dont-ask-for-SIM-PIN-in-greeter.patch. Don't ask for SIM PIN in
      login manager.
    + Add 0033_remove-dangling-window-decorations-from-model.patch. qml &
      plugins: Remove dangling window decorations from model. Latch onto
      MirSurface signal indicating it's not being displayed anymore, and
      remove the window from the TopLevelWindowModel when required.
    + Add 0034_spawn-apps-in-fullscreen-when-in-phone+tablet-mode.patch. Add
      apps in fullscreen mode when Lomiri operates in tablet/phone mode. Fixes
      non-maximized window content, but maximized window decorations for
      GTK-3+4 applications when Lomiri is in staged mode.
  * debian/control:
    + Update versioned D:s on qtmir & co.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 30 Jul 2025 14:42:25 +0200

lomiri (0.5.0-3) unstable; urgency=medium

  * debian/control:
    + Add to R: (lomiri): lomiri-indicator-location.
  * debian/patches:
    + Add 1007_fix-scrolling-issues.patch. Fix scrolling issue. In desktop/
      windowed mode make sure that scroll events get translated to Lomiri
      coordinates, so that content directly under the mouse pointer is scrolled
      and not something else elsewhere on the screen.
    + Add 1018a_Add-shortcut-to-toggle-side-stage.patch and 1018b_Add-shortcut-
      for-moving-apps-between-stages.patch. Support moving apps between main
      stage and side stage via hotkeys.
    + Add 1019_WorkspacePreview-reduce-lag-when-app-enters-exit-ful.patch. Make
      fullscreen switching more smooth.
    + Add patches 1021 - 1028. Various Lomiri-on-desktop improvements esp. for
      managing non-Lomiri windows (such as windows drawn via GTK, Xwayland,
      etc.).
    + Whitespace-fix in 1005_cursor-always-follow-cursor-position-from-mir.patch
      and 1007_fix-scrolling-issues.patch.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 24 Jul 2025 11:56:04 +0200

lomiri (0.5.0-2) unstable; urgency=medium

  * debian/patches:
    + Add 1005_cursor-always-follow-cursor-position-from-mir.patch. Keep cursor
      in sync with Mir if running in a VM.
    + Update/extend 1005_cursor-always-follow-cursor-position-from-mir.patch.
      Set LOMIRI_RUNNING_IN_VM=1 in lomiri-greeter-wrapper script.
    + Add 0030_lomiri-upstream-home-logo.patch. Use upstream Lomiri home
      logo by default. Drop upstream's code that tries to too wisely to show
      the distributor's logo. This we will handle in our debian-lomiri-default-
      settings package.
  * debian/control:
    + Bump versioned D: on lomiri-schemas; lomiri 0.5.0 requires lomiri-schemas
      0.1.8.
  * debian/:
    + Add 91-lomiri-enable-user-list.conf to /etc/lightdm/lightdm.conf.d/.
      Enable user list, disable free-hand login prompt.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 14 Jun 2025 00:42:03 +0200

lomiri (0.5.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Move various lomiri-greeter-wrapper changes into one patch file
      (2014_lomiri-greeter-wrapper-on-wayland.patch).
    + Drop 1018_plugins-Cursor-fix-jumpy-windows-during-edge-snap.patch.
      Not sanctioned upstream.
    + Rebase 2012_no-app-suspension-on-Debian+Ubuntu-proper.patch and
      2009_disable-qtmir-tests.patch.
    + Add 2015_lomiri-greeter-use-wayland.patch.
  * debian/copyright:
    + Update copyright attributions.
  * debian/rules:
    + Explicitly use either Ubuntu or Lomiri logo and copy it to the
      qml/Launcher/graphics/ folder.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 05 May 2025 23:42:11 +0200

=== debian/control ===
Source: lomiri
Section: x11
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
 Marius Gripsgard <mariogrip@debian.org>,
Build-Depends:
 cmake,
 cmake-extras,
 dbus-test-runner <!nocheck>,
 debhelper-compat (= 13),
 dh-apparmor,
 doxyqml,
 graphviz,
 lomiri-schemas (>= 0.1.8-1~),
 lomiri-wallpapers <!nocheck>,
 libdeviceinfo-dev,
 libevdev-dev,
 libgeonames-dev (>= 0.2),
 libgl-dev[!arm64 !armhf],
 libgl1-mesa-dri,
 libgles2-mesa-dev[arm64 armhf],
 libglib2.0-dev,
 libgnome-desktop-3-dev,
 libgsettings-qt-dev,
 liblightdm-qt5-3-dev,
 liblomiri-connectivity-qt1-dev,
 libpam0g-dev,
 libpulse-dev,
 libqmenumodel-dev (>= 0.2.12),
 libqtmirserver-dev (>= 0.8.0~git20250407.ea2f477-3~),
 libmiroil-dev,
 libmiral-dev,
 libqt5sql5-sqlite,
 libqt5svg5-dev,
 libqt5xmlpatterns5-dev,
 libqtdbusmock1-dev (>= 0.7) <!nocheck>,
 libqtdbustest1-dev <!nocheck>,
 libsystemd-dev [linux-any],
 liblomirisystemsettings-dev,
 liblomiri-app-launch-dev (>= 0.1.5),
 liblomiri-download-manager-common-dev,
 liblomirigestures-dev (>= 1.3.2030),
 liblomirigestures5-private-dev (>= 1.3.2030),
 libudev-dev,
 libldm-common-dev,
 liblomiri-api-dev (>= 0.2.0),
 libusermetricsoutput-dev,
 libx11-dev[!arm64 !armhf],
 libxcb1-dev[!arm64 !armhf],
 libxi-dev[!arm64 !armhf],
 libxcb-dri2-0-dev[!arm64 !armhf],
 licensecheck,
 mir-platform-graphics-x,
 mirtest-dev <!nocheck>,
 pkgconf,
 python3-all:any,
 python3-setuptools,
 qml-module-qt-labs-folderlistmodel,
 qml-module-qt-labs-settings,
 qml-module-qtmultimedia (>= 5.6),
 qml-module-qtqml-statemachine,
 qml-module-qtquick-layouts,
 qml-module-qtquick-xmllistmodel,
 qml-module-qtquick2,
 qml-module-qtsysteminfo,
 qml-module-qttest <!nocheck>,
 qml-module-lomiri-components (>= 1.3.5000),
 qml-module-lomiri-layouts,
 qml-module-lomiri-settings-components,
 qml-module-lomiri-settings-menus,
 qml-module-lomiri-test <!nocheck>,
 qml-module-qtmir (>= 0.8.0~git20250407.ea2f477-3~),
 qtbase5-dev (>= 5.6),
 qtbase5-dev-tools,
 qtbase5-private-dev (>= 5.6),
 qtdbustest-runner <!nocheck>,
 qtdeclarative5-dev (>= 5.6),
 qtdeclarative5-dev-tools,
 qtdeclarative5-private-dev (>= 5.6),
 qml-module-lomiri-content,
 systemd-dev [linux-any],
# fonts-ubuntu,
 xvfb <!nocheck>,
 xauth <!nocheck>,
 xwayland,
# mirtest pkgconfig requires these, but doesn't have a deb dependency. Bug lp:1633537
 libboost-filesystem-dev,
 libboost-system-dev,
 rdfind,
 symlinks,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/lomiri
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri.git
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri

Package: lomiri-greeter
Architecture: all
Depends:
 lomiri (>= ${source:Version}), lomiri (<< ${source:Version}.1~),
 lightdm,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 lomiri-keyboard,
Conflicts:
 arctica-greeter,
 arctica-greeter-guest-session,
 arctica-greeter-remote-logon,
 unity-greeter,
Provides:
 lightdm-greeter,
Description: LightDM Greeter for the Lomiri Operating Environment
 Lomiri is an operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package provides the Lomiri Greeter.

Package: lomiri
Architecture: any
Provides:
 indicator-renderer,
 notification-daemon
Depends:
 ayatana-indicator-bluetooth,
 ayatana-indicator-display,
 ayatana-indicator-keyboard,
 ayatana-indicator-messages,
 ayatana-indicator-power,
 ayatana-indicator-session,
 ayatana-indicator-sound,
 lomiri-app-launch (>= 0.1.5),
 dmz-cursor-theme,
 gsettings-desktop-schemas,
 libcap2-bin,
 libglib2.0-bin,
 qml-module-biometryd,
 qml-module-lomiri-components,
 qml-module-lomiri-layouts,
 qml-module-lomiri-telephony,
 qml-module-lomiri-settings-menus,
 qml-module-qmenumodel1,
 qml-module-qt-labs-folderlistmodel,
 qml-module-qt-labs-settings,
 qml-module-qtmir (>= 0.8.0~git20250407.ea2f477-3~),
 qml-module-qtqml-statemachine,
 qml-module-qtquick-xmllistmodel,
 qml-module-qtsysteminfo,
 qml-module-hfd,
 qtmir (>= 0.8.0~git20250407.ea2f477-3~),
 lomiri-indicator-datetime,
 lomiri-indicator-network,
 lomiri-system-settings (>= 1.2.0-1~),
 lomiri-url-dispatcher,
 lomiri-launcher-impl-13,
 lomiri-common (>= ${source:Version}), lomiri-common (<< ${source:Version}.1~),
 liblomiri-private0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 ciborium,
 mir-platform-graphics-gbm-kms | mir-platform-graphics-eglstream-kms | mir-platform-graphics-wayland | mir-platform-graphics-x,
 lomiri-desktop-session | lomiri-touch-session,
 lomiri-greeter,
 lomiri-greeter-session-broadcast,
 lomiri-indicator-transfer,
 lomiri-indicator-location,
 lomiri-polkit-agent,
 lomiri-keyboard,
Breaks:
 indicator-network (<< 0.5.1+14.10.20141014),
 lomiri-keyboard (<< 0.100),
 lomiri-touch-session (<< 0.107),
 lomiri-scope-tool,
Replaces:
 lomiri-touch-session (<< 0.82~),
 lomiri-scope-tool,
Conflicts:
 lomiri-system-settings-wizard,
Description: Shell of the Lomiri Operating Environment
 Shell of the Lomiri Operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package provides the Lomiri shell.

Package: lomiri-common
Architecture: all
Depends:
 ayatana-greeter-badges,
 qml-module-qtquick-layouts,
 qml-module-lomiri-components (>= 1.3.2030) | qml-module-lomiri-components-gles (>= 1.3.2030),
 qml-module-lomiri-settings-components,
 qml-module-lomiri-thumbnailer,
 qtdeclarative5-lomiri-notifications-plugin (>= 0.1.2) | lomiri-notifications-impl,
 qttranslations5-l10n,
 lomiri-application-impl-27,
 lomiri-notifications-impl-3,
 lomiri-schemas (>= 0.1.8-1~),
 lomiri-tests <!nocheck> | lomiri-application-impl,
 ${misc:Depends},
Description: Shell of the Lomiri Operating Environment (common files)
 Shell of the Lomiri Operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package contains the QML, graphics and locale files for lomiri.

Package: lomiri-tests
Architecture: any
Multi-Arch: foreign
Depends:
 dbus-test-runner,
 parallel,
 qtdbustest-runner,
 qtdeclarative5-dev-tools,
 lomiri (= ${binary:Version}),
 xauth,
 xvfb,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 lomiri-application-impl,
 lomiri-application-impl-27,
 lomiri-fake-env,
Replaces:
 lomiri-autopilot (<< 8.02+15.04.20150422-0lomiri1),
 lomiri-fake-env,
Conflicts:
 lomiri-fake-env,
Build-Profiles: <!nocheck>
Description: Scripts and mocks for running Lomiri Shell tests
 Lomiri is an operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package provides fake implementations of some QML modules used by
 the Lomiri Shell (e.g. Lomiri.Application) so that you can run it in a
 sandboxed environment; it also provides scripts to run its test suite.

Package: liblomiri-private0
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 lomiri-schemas (>= 0.1.8-1~),
 qml-module-gsettings1.0,
 qml-module-qtmultimedia,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 lomiri-launcher-impl,
 lomiri-launcher-impl-13,
Breaks:
 lomiri-private,
Replaces:
 lomiri-private,
Description: Lomiri Operating Environment's Shell (private libs)
 Lomiri is an operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package contains the private libraries for QML and other components
 only used by the Lomiri Shell.

Package: lomiri-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Lomiri Operating Environment's Shell (documentation files)
 Lomiri is an operating environment optimized for touch based
 human-machine interaction, but also supporting convergence (i.e.
 switching between tablet/phone and desktop mode). Lomiri is the user
 shell driving Ubuntu Touch based mobile devices.
 .
 This package provides documentation of the Lomiri Shell.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/default.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DPKG_GENSYMBOLS_CHECK_LEVEL=4
export NO_PNG_PKG_MANGLE=1
export QT_SELECT=qt5

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
include /usr/share/dpkg/buildflags.mk

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# Skip tests on the archs they are known to be flaky  with current configuration
testskip_architectures := arm64 powerpc ppc64el s390x

ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
export CONFIGURE_FLAGS := -DENABLE_UBUNTU_ACCOUNTSSERVICE=ON
endif

ifneq ($(filter nocheck,$(DEB_BUILD_PROFILES)),)
    CONFIGURE_FLAGS += -DNO_TESTS=ON
endif

%:
	dh $@

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_configure:
	# Debian defines CMAKE_INSTALL_LOCALSTATEDIR as /usr/var, which is wrong.
	# So until Debian bug 719148 is fixed, do it ourselves.
	dh_auto_configure -- -DCMAKE_INSTALL_LOCALSTATEDIR="/var" \
	                     -DDISPLAYED_DISTRO_NAME="Debian Lomiri" \
	                     -DWITH_MIR2=ON \
	                     $(CONFIGURE_FLAGS)

override_dh_auto_build:
	# doc is not a default target
	dh_auto_build -- -O all doc

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	mkdir -p debian/home
	export HOME=debian/home
	# Run the entire test battery
	# Parallel tests have a risk of starting xvfb on the same DISPLAY multiple times,
	# causing the whole battery to fail.
ifneq (,$(filter $(DEB_HOST_ARCH),$(testskip_architectures)))
	-dh_auto_test --no-parallel -- -O -k xvfballtests
else
	# FIXME: Temporarily disable unit tests on all other architectures, as well. They
	# seem flaky when built+run on systems more recent than Ubuntu 20.04...
	dh_auto_test --no-parallel -- -O -k xvfballtests
endif
endif

override_dh_fixperms:
	dh_fixperms
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Session/libSessionBackendTestPreload.so || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/abs-icon.desktop || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/click-icon.desktop || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/click-icon.svg || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/no-name.desktop || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/rel-icon.desktop || true
	[ -d debian/lomiri-tests ] && chmod a-x debian/lomiri-tests/usr/libexec/lomiri/tests/plugins/Lomiri/Launcher/applications/rel-icon.svg || true

override_dh_install:
	rm debian/tmp/usr/bin/indicators-client
	rm debian/tmp/usr/share/applications/indicators-client.desktop
	rm debian/tmp/usr/share/lomiri/unlock-device
	rm debian/tmp/usr/lib/systemd/user/*.service
	cd debian/tmp/usr/share/doc/lomiri/html/ && rdfind -makesymlinks true .
	cd debian/tmp/usr/share/doc/lomiri/html/ && symlinks -rc .
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
	cp debian/home-ubuntu.svg debian/tmp/usr/share/lomiri/Launcher/graphics/home.svg
else
	cp debian/home-lomiri.svg debian/tmp/usr/share/lomiri/Launcher/graphics/home.svg
endif
	dh_install

override_dh_installdocs:
	dh_installdocs
	# Remove results.txt for reproducible builds
	rm -vf debian/lomiri-doc/usr/share/doc/lomiri/html/results.txt

# use private lib directories
override_dh_makeshlibs:
	dh_makeshlibs -Nlomiri-tests

override_dh_shlibdeps:
	# Some mock libraries link against liblightdm-qt5-3.so which we want to
	# avoid, since we only really link against our mock one, not the system one.
	dh_shlibdeps -XlibMockAccountsService-qml.so -Lliblomiri-private0

override_dh_clean:
	rm -Rfv debian/home
	dh_clean

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..
